[leetcode-292]Nim Game(java)

问题描述:
You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

分析:这道题我最开始想到的是回溯法,结果发现超时。静下心来好好分析发现,非常有意思的。
试想,如果我想赢,那么最后一步一定是我面对的石子小于等于3个。这样我稳赢。要达到这种效果,那么必须要求对方一定位于倒数第四个。注意是一定,早一个或者晚一个都不行。那要保证对方一定位于倒数第四个,那么我一定位于倒数第5、6、7的位置处。不知道发现了什么没有。
如果n对4取余,如果整除的话,那么相当于我处在对方的位置,稳输。如果不是,位于第1、2、3个的位置上,那么我会稳赢。

代码如下:0ms

public class Solution {
    public boolean canWinNim(int n) {
        int val = n%4;
        if(val >= 1 && val <= 3)
            return true;
        return false;
    }
}
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值